library ReadLine;

uses
  SysUtils,
  Windows,
  Classes,
  Controls;

{$R *.RES}

Const  Inputs  = 3; // number of inputs
       Outputs = 2; // number of outputs made adjustable

       {INPUTS}
       ZEILE = 0;   // index of input variable ZEILENNUMMER
       RST   = 1;   // index of input variable RST
       FName = 2;

       {OUTPUTS}
       bEOF = 0;
       SOUT = 1;

       {USER}
       RST_old  = 1;          // index of user variable RST_old
       DLLINDEX = 100;

Type TDLLParams = array[0..100] of extended;   //Type of ProfiLab DLL parameters
     PDLLParams = ^TDLLParams;                 // Pointer to ProfiLab DLL parameters

Type TStringParams = array[0..100] of PChar;
     PStringParams = ^TStringParams;


function NumInputs: Byte;
begin
  result:= Inputs; //Define FIXED number of component input pins
end;

function NumOutputs: Byte; // Made adjustable with 'NumOutputsEx'
begin
  result:= Outputs; //Define FIXED number of component output pins
end;

Function InputName(Channel: Byte): ShortString; // Return name for each component input pin
begin
   case Channel of
   ZEILE: result:= 'i';     //  "Zeilennr."
   RST:   result:= '/RST';  //  "/RST" (NOT RESET)
   FName: result:= '$File';
   end;
end;

Function OutputName(Channel: Byte): ShortString; // Return name for each component output pin
begin
   case Channel of
   bEOF:  result:= '/EOF';
   SOUT:  result:= '$LN';
   end;
end;

Procedure SimStart(PInput,POutput,PUser: PDLLParams; PStrings: PStringParams); //called when ProfiLab enters RUN mode
var Filename,Datenstring : string;
    Datei : TEXT;
begin
  PUser^[RST_old]:= 0;
  Datenstring:= '';
  POutput^[bEOF]:=  0;
end;

Procedure SimStop(PInput,POutput,PUser: PDLLParams); //called when ProfiLab RUN mode is terminated
begin
  // nothing to be done
end;

Procedure CalculateEx(PInput,POutput,PUser: PDLLParams; PStrings: PStringParams); //called regularly from ProfiLab
var Filename,Datenstring,s : string;
    Zeilennummer,i : longint;
    Datei : TEXT;
begin
  Filename:= AnsiString(PStrings^[FName]);
  Zeilennummer:= round(PInput^[Zeile]);
  Datenstring:= '';
  POutput^[bEOF]:= 5;

  {$I-}
  if filename <> '' then
  begin
    assignfile(Datei,Filename);

    if PInput^[RST] < 2.5 then //check RST input HIGH or LOW
    begin
      if (not (PInput^[RST] >= 2.5)) and (PUser^[RST_old] > 2.5) then //check out falling edge at RST input
      begin //Reset
        Zeilennummer:= 0;
        reset(Datei);
        readln(Datei,Datenstring);
        StrPCopy(PStrings[SOUT],PChar(Datenstring));
        closefile(Datei);
      end;
      PUser^[RST_old]:= PInput^[RST]; //Remember RST status for next call
      exit;
    end;
    PUser^[RST_old]:= PInput^[RST]; //Remember RST status for next call

    reset(Datei);
    if ioresult = 0 then
    begin
      i:= 0;
      repeat
        readln(Datei,s);
        inc(i);
      until ((i > Zeilennummer) or (ioresult <> 0));

      if EOF(Datei) then POutput^[bEOF]:= 0;
      Datenstring:= s;
    end;
    CloseFile(Datei);
  end
  else POutput^[bEOF]:= 0;
  {$I+}

  StrPCopy(PStrings^[SOUT],PChar(Datenstring));
end;

Procedure Configure(PUser: PDLLParams);
begin
end;

//export methods for ProfiLab
exports SimStart,
        SimStop,
        NumInputs,
        NumOutputs,
        CalculateEx,
        InputName,
        OutputName,
        Configure;
begin
end.


